public class GazetteSettings : Pantheon.Switchboard.Plug {
    static Gtk.Widget no_settings = new Gtk.Label("This widget has no settings");
    Gee.Collection<Gazette.Plugin.Base> services;
    Settings settings;
    string [] enabled_services;
    Gtk.Widget current_conf;

    public GazetteSettings () {
        settings = new Settings ("org.pantheon.gazette");
        enabled_services = settings.get_strv("enabled-services");
        var manager = new Gazette.PluginManager (settings, "enabled-services", Constants.PLUGINDIR);
        manager.load_plugins ();
        services = manager.get_plugins ();

        var box  = new Gtk.Box   (Gtk.Orientation.HORIZONTAL, 0);
        var list = new Gtk.Box   (Gtk.Orientation.VERTICAL, 0);
        var view = new Gtk.Box   (Gtk.Orientation.VERTICAL, 0);
        var scrl = new Gtk.ScrolledWindow (null, null);

        scrl.add_with_viewport (list);
        scrl.width_request = 300;
        list.margin = 12;

        box.pack_start (scrl, false);
        box.pack_start (view);
        var cur_box   = new Gtk.Box (Gtk.Orientation.HORIZONTAL, 20);
        var cur_label = new Gtk.Label ( _("Setup your\nnews services") );
//        var cur_image = new Gtk.Image.from_icon_name (
//            "gazette", Gtk.IconSize.DIALOG);
//        cur_image.pixel_size = 64;

        var attrs = new Pango.AttrList ();
        attrs.insert (new Pango.AttrFontDesc (
        Pango.FontDescription.from_string ("bold 25")));
        cur_label.set_attributes (attrs);

        cur_label.halign = Gtk.Align.START;
//        cur_box.pack_start (cur_image, false);
        cur_box.pack_start (cur_label);

        view.pack_start (cur_box, false);
        view.margin = 30;

        foreach (Gazette.Plugin.Base p in services) {
            var list_item = get_item_for(p);
            list.pack_start (list_item, false);
            list_item.button_press_event.connect ( () => {
                cur_label.label = p.name;
                var config_widget = p.create_config_widget ();
                if (current_conf != null)
                    view.remove(current_conf);
                if (config_widget != null) {
                    view.add(config_widget);
                    view.show_all();
                    current_conf = config_widget;
                }
                else {
                    view.add(no_settings);
                    current_conf = no_settings;
                    view.show_all();
                }
                return false;
            });
        }
        this.add (box);
    }

    private string[] remove_value (string val, string[] values) {
        string[] new_values = {};
        foreach (var v in values) {
            if (v != val)
                new_values += v;
        }
        return new_values;
    }

    private Gtk.EventBox get_item_for (Gazette.Plugin.Base p) {
        var item = new Gtk.EventBox ();
        var item_c = new Gtk.Box (Gtk.Orientation.HORIZONTAL, 5);
        item.add(item_c);
        var label = new Gtk.Label (p.name);
        var toggle = new Gtk.Switch ();
        toggle.valign = Gtk.Align.CENTER;
        toggle.set_active(p.id in enabled_services);
        toggle.notify["active"].connect(() => {
            if (toggle.active) {
                enabled_services += p.id;
                settings.set_strv ("enabled-services", enabled_services);
            }
            else {
                enabled_services = remove_value(p.id, enabled_services);
                settings.set_strv ("enabled-services", enabled_services);
            }
        });
        item_c.pack_start (label, true);
        item_c.pack_start (toggle, false);
        return item;
    }
}

public static int main(string[] args){

    Gtk.init(ref args);

    var SwitchBoard_Plug = new GazetteSettings();
    SwitchBoard_Plug.register(_("News Columns"));
    SwitchBoard_Plug.show_all();
    Gtk.main();
	return 0;
}
