
public class Files : Gazette.Plugin.Base
{
    List<Gtk.RecentInfo> last_files;
    Settings settings;
    public override Service service {get; protected set;}
    construct {
        name = _("Files");
        id = "files";
    }
    public Files () {
        settings = new Settings("org.pantheon.gazette.files");
    }
    public override Service create_service () {
        service = new Service (this);
        last_files = Gtk.RecentManager.get_default ().get_items ();
        set_update_interval(settings.get_int("update-interval"));
        service.title = _("Files");
        return service;
    }
    public override bool update () {
        debug("Updating Recent Files");
        service.clear_contents ();
        for (var i = 0; i < 10 && i < last_files.length (); i++) {
            var aux = ellipsize (last_files.nth_data (i).get_display_name (), 40);
            service.add_content_with_link(aux, last_files.nth_data (i).get_uri ());
        }
        return true;
    }
    public override Gtk.Widget? create_config_widget () {
        return null;
    }
}

public Files plugin_init () {
    // types are registered automatically
    return new Files ();
}
