public class Time : Gazette.Plugin.Base {
    ShadowedLabel label;
    public override Service service {get; private set;}
    construct {
        id = "time";
        name = _("Time");
    }
    public override Service create_service () {
        service = new Service (this);
        set_update_interval(1000);
        label = new ShadowedLabel("");
        service.add_content(label);
        return service;
    }
    public override bool update () {
        var date = new GLib.DateTime.now_local ();
        var day_format = _("%A, %B %e");
        // TODO provide a localizable date suffix
        string tfmt = (new Settings("org.gnome.desktop.interface")). get_string ("clock-format");
        var time_format = _("<span weight='bold'>" + ((tfmt=="12h")?"%l":"%H") + ":</span><span weight='ultralight'>%M</span>");
        label.label = date.format (
            "\n<span face='Raleway' font='80'>"+
            time_format+
            "</span>\n<span face='Open Sans Light' font='24'>"+
            day_format+
            "</span>");
        return true;
    }
    public override Gtk.Widget? create_config_widget () {
        return null;
    }
}
public Time plugin_init () {
    // types are registered automatically
    return new Time ();
}
